You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

1300 lines
30 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __ln=$'\n'
  21. __cr=$'\r'
  22. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  23. mkdir -p "$TMP"
  24. __homerun="$HOME/.var/run"
  25. mkdir -p "$__homerun"
  26. ##########################
  27. # system type
  28. gnu_coreutils=false # for mac
  29. null ls --version && gnu_coreutils=true
  30. inbash=false
  31. inzsh=false
  32. if test -n "$BASH_VERSION"
  33. then
  34. inbash=true
  35. elif test -n "$ZSH_VERSION"
  36. then
  37. inzsh=true
  38. fi
  39. #################################
  40. # file pathes:
  41. # shrc: Path to this file
  42. if $inbash
  43. then
  44. __shrc="$BASH_SOURCE"
  45. elif $inzsh
  46. then
  47. __shrc="$0"
  48. fi
  49. #########################
  50. # system detection
  51. __system_shrc="$__homerun/system.shrc"
  52. if test -f "$__system_shrc"
  53. then
  54. . "$__system_shrc"
  55. else
  56. ismsys=false
  57. iscygwin=false
  58. iswindows=false
  59. isdarwin=false
  60. isfreebsd=false
  61. isbsd=false
  62. islinux=false
  63. # $OSTYPE is another choice. which is better?
  64. # NOTE: sh on FreeBSD does not define OSTYPE
  65. case `uname` in
  66. MINGW*) ismsys=true ;;
  67. CYGWIN*) iscygwin=true ;;
  68. Darwin*) isdarwin=true ;;
  69. FreeBSD*) isfreebsd=true ;;
  70. Linux*) islinux=true ;;
  71. esac
  72. ($ismsys || $iscygwin) && iswindows=true
  73. # is this true?
  74. ($isdarwin || $isfreebsd) && isbsd=true
  75. # dump system detection result
  76. cat <<__EOC__ >"$__system_shrc"
  77. #!/bin/sh
  78. # $__system_shrc
  79. ismsys=$ismsys
  80. iscygwin=$iscygwin
  81. iswindows=$iswindows
  82. isdarwin=$isdarwin
  83. isfreebsd=$isfreebsd
  84. isbsd=$isbsd
  85. islinux=$islinux
  86. __EOC__
  87. fi
  88. $ismsys && export HOSTNAME
  89. # adhoc fix for ansible on cygwin
  90. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  91. if $iscygwin
  92. then
  93. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  94. fi
  95. ##########################
  96. # Terminal setups
  97. if ! $iswindows && null type stty
  98. then
  99. stty stop undef # unbind C-s to stop displaying output
  100. # stty erase '^h'
  101. fi
  102. # Zsh specific preferences
  103. # http://www.clear-code.com/blog/2011/9/5.html
  104. if $inzsh
  105. then
  106. bindkey -e
  107. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  108. autoload compinit; compinit
  109. # supress cycle by tab
  110. unsetopt auto_menu
  111. # unsetopt correct
  112. setopt complete_aliases
  113. setopt auto_list
  114. setopt bash_auto_list
  115. setopt magic_equal_subst
  116. setopt list_types
  117. # what is the difference of these two?
  118. setopt auto_param_slash
  119. setopt mark_dirs
  120. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  121. zstyle ':completion:*' format '%B%d%b'
  122. zstyle ':completion:*' group-name ''
  123. zstyle ':completion:*' use-cache yes
  124. # zstyle ':completion:*:cd:*' tag-order local-directories
  125. zstyle ':completion:*' completer _complete _bash_completions \
  126. _history
  127. # zstyle ':completion:*:*:cd:*' completer
  128. zstyle ':completion:*' accept-exact-dirs true
  129. zstyle ':completion:*' special-dirs true
  130. autoload colors; colors
  131. # autoload -Uz promptinit
  132. # promptinit
  133. # prompt walters
  134. setopt hist_ignore_dups
  135. setopt hist_ignore_all_dups
  136. setopt hist_save_no_dups
  137. setopt extended_history
  138. setopt share_history
  139. setopt append_history
  140. HISTFILE=$HOME/.zsh-history
  141. HISTSIZE=100000
  142. SAVEHIST=100000
  143. setopt prompt_subst
  144. setopt interactive_comments
  145. fi
  146. ######################
  147. # Print welcome messages
  148. command -v fortune >/dev/null && {
  149. if command -v cowsay >/dev/null
  150. then
  151. fortune | cowsay
  152. echo
  153. fortune -o | cowsay
  154. echo
  155. else
  156. fortune
  157. echo
  158. fortune -o
  159. echo
  160. fi
  161. }
  162. uname -a
  163. $iswindows && alias tty="echo cmd.exe"
  164. echo TERM $TERM with $(tput colors) colors using $(tty)
  165. echo umask: `umask -S`
  166. echo
  167. __safe_run w yuk
  168. # if null type tmux
  169. # then
  170. # echo
  171. # echo tmux sessions:
  172. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  173. # echo
  174. # fi
  175. # if test -n "$TMUX"
  176. # then
  177. # tmux display -p \
  178. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  179. # 2>/dev/null
  180. # echo
  181. # fi
  182. i(){
  183. w
  184. ss -lnp
  185. ps aufx
  186. df -h
  187. top -b -d 1 -n 1
  188. top -b -d 1 -n 1 -a
  189. dstat -taf 1 10
  190. }
  191. ###################################
  192. # some aliases and functions
  193. # __func_name: never used interactively
  194. # _func_name: usually not used interactively
  195. __safe_alias(){
  196. # __safe_alias <name>=<command>
  197. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  198. test -n "$_bin" && \
  199. null type $_bin && \
  200. alias "$1"
  201. }
  202. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  203. # color prefs
  204. if $gnu_coreutils
  205. then
  206. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  207. # gnu coreutils LS_COLORS is used
  208. null type dircolors && eval `dircolors`
  209. _coloroption=" --color=auto"
  210. else
  211. # export LSCOLORS=gxfxcxdxbxegedabagacad
  212. export LSCOLORS=DxGxcxdxCxegedabagacad
  213. export CLICOLOR=1
  214. fi
  215. alias ls="ls -hCF${_coloroption}${_timeoption}"
  216. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  217. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  218. _timeformat_num="%Y%m%d%H%M%S"
  219. alias datenum="date +$_timeformat_num"
  220. # export GREP_OPTIONS=""
  221. alias gr="grep -n --color=always"
  222. $iswindows && alias gr="grep -n"
  223. alias less="less -F"
  224. __safe_alias em="emacs -nw"
  225. __safe_alias vi=vim
  226. alias pstree="LANG=C pstree"
  227. alias cp="cp -v"
  228. alias mv="mv -v"
  229. alias rm="rm -v"
  230. alias mkdir="mkdir -v"
  231. alias rmdir="rmdir -v"
  232. alias psaux="ps auxww"
  233. alias modest="ionice -c 2 -n 7 nice -n 19"
  234. alias e=exec
  235. alias q=exit
  236. __safe_alias e3=e3em
  237. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  238. alias po=popd
  239. alias pu=pushd
  240. __safe_alias sudo="sudo " # use aliases through sudo
  241. __safe_alias sudoe="sudoedit"
  242. # __safe_alias halt="sudo halt"
  243. # __safe_alias reboot="sudo reboot"
  244. null type dbus-send && {
  245. alias suspend="dbus-send --system --print-reply \
  246. --dest=org.freedesktop.UPower \
  247. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  248. alias hibernate="dbus-send --system --print-reply \
  249. --dest=org.freedesktop.UPower \
  250. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  251. }
  252. alias rand="echo \$RANDOM"
  253. __safe_alias xunp="file-roller -h"
  254. __safe_alias pc="sudo \paco -D"
  255. alias pycalc="python -i -c 'from math import *' "
  256. __safe_alias py3=python3
  257. __safe_alias py2=python2
  258. __safe_alias ipy=ipython
  259. __safe_alias ipy3=ipython3
  260. __safe_alias ipy2=ipython2
  261. __safe_alias javac="javac -J-Duser.language=en"
  262. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  263. # SHELL is set to be /bin/zsh
  264. if $inbash
  265. then
  266. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  267. elif $inzsh
  268. then
  269. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  270. else
  271. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  272. fi
  273. # alias mytime="date +%Y%m%d-%H%M%S"
  274. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  275. # some extra utilities
  276. # type trash >/dev/null 2>&1 && alias rm=trash
  277. __safe_alias mpg123="mpg123 -C -v --title"
  278. __safe_alias xm="xmms2"
  279. #export PLAYER="mpg123 -C -v --title"
  280. __safe_alias screen="screen -e^z^z"
  281. #alias zcd="cd \`zenity --file-selection --directory\`"
  282. __safe_alias gtags="gtags --verbose"
  283. __safe_alias htags="htags --xhtml --symbol --line-number \
  284. --frame --alphabet --verbose"
  285. __safe_alias au=aunpack
  286. # __safe_alias lv="lv|less"
  287. __safe_alias rs="rsync --progress --itemize-changes --compress"
  288. __safe_alias vagr=vagrant
  289. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  290. if $iscygwin
  291. then
  292. __my_wget_options=" --no-check-certificate"
  293. __safe_alias wget="wget $__my_wget_options"
  294. fi
  295. if $isdarwin
  296. then
  297. alias updatedb="LC_ALL=C updatedb"
  298. # do not use locate installed by macports
  299. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  300. fi
  301. # somehow not work
  302. # typeset -ga chpwd_functions
  303. # chpwd_functions+=pwd
  304. # chpwd(){
  305. # pwd
  306. # }
  307. cd(){
  308. builtin cd "$@" && pwd
  309. }
  310. root(){
  311. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  312. then
  313. cd "`git rev-parse --show-toplevel`"
  314. else
  315. cd /
  316. fi
  317. }
  318. # pad
  319. alias pad=notepad
  320. __safe_alias pad=gedit
  321. __safe_alias pad=leafpad
  322. $isdarwin && alias pad="open -e"
  323. __find_latest_vimdir(){
  324. vimdir=/usr/share/vim
  325. if test -d "$vimdir"
  326. then
  327. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  328. else
  329. echo ""
  330. fi
  331. }
  332. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  333. do
  334. test -n "$f" || continue
  335. f="$f/macros/less.sh"
  336. test -f $f && alias vl=$f && break
  337. done
  338. __safe_alias pa="pacman --color=always"
  339. __safe_alias pa="pacmatic --color=always"
  340. __safe_alias pa="pacapt"
  341. __safe_alias yt=yaourt
  342. # variable for yaourt
  343. null type pacmatic && export PACMAN="pacmatic"
  344. __safe_alias cower="cower --color=auto"
  345. __my_pacman_update_mirrorlist_with_reflector(){
  346. f=/etc/pacman.d/mirrorlist
  347. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  348. if test -z "$cmd"
  349. then
  350. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  351. fi
  352. echo ">>> $cmd ..." 1>&2
  353. sudo sh -c "$cmd" && cat $f
  354. }
  355. null type reflector && test -d /etc/pacman.d && \
  356. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  357. null type apt-get && {
  358. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  359. apt-get update --yes && apt-get upgrade --yes'"
  360. alias aptin="apt-get install"
  361. alias aptsearch="apt-cache search"
  362. alias aptshow="apt-cache show"
  363. }
  364. null type port && {
  365. alias port="port -v"
  366. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  367. port -v upgrade outdated'"
  368. }
  369. if $iscygwin
  370. then
  371. null type windate || \
  372. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  373. # alias cygsu="cygstart /cygwinsetup.exe"
  374. fi
  375. mkpatch(){
  376. if test $# -eq 0
  377. then
  378. echo "usage: mkpatch <olddir> <newdir>"
  379. elif ! test -d "$1"
  380. then
  381. echo "mkpatch: $1 is not a directory"
  382. elif ! test -d "$2"
  383. then
  384. echo "mkpatch: $2 is not a directory"
  385. else
  386. diff -Naur "$1" "$2"
  387. fi
  388. }
  389. __sdcv_less(){
  390. command sdcv -n "$@" | less --quit-if-one-screen
  391. }
  392. command -v sdcv >/dev/null && alias dict=__sdcv_less
  393. g(){
  394. if test $# -eq 0 && null type git-info
  395. then
  396. git info
  397. else
  398. git "$@"
  399. fi
  400. }
  401. if null type _git && $inbash
  402. then
  403. # enable programmable completion for g
  404. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  405. || complete -o default -o nospace -F _git g
  406. fi
  407. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  408. __safe_alias m=gitmemo
  409. alias setup.py3="sudo python3 setup.py install --record files.txt"
  410. randomstr(){
  411. len=$1
  412. test -z "$len" && len=8
  413. uuidgen | tr -d - | cut -c 1-len
  414. }
  415. datestr(){
  416. # datestr YYYYMMDDhhmmss
  417. if test -z "$1" || test "$1" = "-h"
  418. then
  419. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  420. return 1
  421. fi
  422. # actual format for date command
  423. dfmt="`echo "$1" | \
  424. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  425. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  426. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  427. date +"$dfmt"
  428. }
  429. # ssh(){
  430. # # __my_terminal_title ssh
  431. # command ssh "$@"
  432. # }
  433. __ssh_with_cd(){
  434. # __ssh_with_cd <host> <directory> [<arg> ...]
  435. if test -z "$2"
  436. then
  437. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  438. return 1
  439. fi
  440. host="$1"
  441. shift
  442. dir="$1"
  443. shift
  444. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  445. }
  446. memo(){
  447. if test -z "$1"
  448. then
  449. _memo="memo.txt"
  450. else
  451. _memo="$1/memo.txt"
  452. fi
  453. $EDITOR "$_memo"
  454. if test -z "`cat "$_memo"`"
  455. then
  456. echo "$_memo is empty. Removing."
  457. rm "$_memo"
  458. fi
  459. }
  460. now(){
  461. ___tformat="%Y/%m/%d %H:%M:%S %z"
  462. cal
  463. REPLY=
  464. printf "\\r`date "+${___tformat}"`"
  465. read -t 1
  466. while test $? -ne 0
  467. do
  468. printf "\\r`date "+${___tformat}"`"
  469. read -t 1
  470. done
  471. }
  472. s(){
  473. if git rev-parse --git-dir >/dev/null 2>&1
  474. then
  475. echo ">> git grep -n $@" 1>&2
  476. git grep -n "$@"
  477. elif which ag >/dev/null 2>&1
  478. then
  479. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  480. ag --pager="$PAGER" "$@"
  481. elif which ack >/dev/null 2>&1
  482. then
  483. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  484. ack --pager="$PAGER" "$@"
  485. else
  486. echo \
  487. ">> find . " \
  488. "-path '*/.git' -prune -o" \
  489. "-path '*/.svn' -prune -o" \
  490. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  491. if test $# -eq 0
  492. then
  493. echo "No search word given." 1>&2
  494. return 1
  495. fi
  496. find . \
  497. -path '*/.git' -prune -o \
  498. -path '*/.svn' -prune -o \
  499. -type -f -exec grep -nH -e --color=always "$@" {} + \
  500. | $PAGER
  501. fi
  502. }
  503. MYMANPATH='/usr/lib/erlang/man'
  504. if $inbash || $inzsh
  505. then
  506. man(){
  507. env \
  508. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  509. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  510. LESS_TERMCAP_me=$(printf "\e[0m") \
  511. LESS_TERMCAP_se=$(printf "\e[0m") \
  512. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  513. LESS_TERMCAP_ue=$(printf "\e[0m") \
  514. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  515. MANPATH="`manpath`:$MYMANPATH" \
  516. man "$@"
  517. }
  518. fi
  519. netwait(){
  520. while ! ping -c 1 -t 1 example.com
  521. do
  522. true
  523. done
  524. echo network works.
  525. }
  526. __realpath(){
  527. if type realpath >/dev/null 2>&1
  528. then
  529. command realpath "$@"
  530. else
  531. while ! test -d $1
  532. do
  533. shift
  534. done
  535. (command cd "$d" && echo "$PWD")
  536. # local d="$OLDPWD"
  537. # command cd "$1"
  538. # echo "$PWD"
  539. # command cd "$d"
  540. fi
  541. }
  542. if $isdarwin
  543. then
  544. # I want to use env -u, but darwin env does not provide this option
  545. __safe_alias tmux='SHLVL= tmux'
  546. else
  547. __safe_alias tmux='env -u SHLVL tmux'
  548. fi
  549. tx(){
  550. tmux start-server
  551. if test -z "$1"
  552. then
  553. echo "usage: tx <session_name>"
  554. tmux list-sessions
  555. elif test -z "$TMUX"
  556. then
  557. # -A: attach if already exists
  558. # tmux new-session -A -c "$HOME" -s "$1"
  559. tmux new-session -A -s "$1"
  560. else
  561. # create new session if not exists yet
  562. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  563. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  564. tmux switch-client -t "$1"
  565. fi
  566. }
  567. dt(){
  568. # dt [-h] [<name>] [<command ...>]
  569. __dtach_dir="${TMP}/dtach"
  570. mkdir -p "${__dtach_dir}"
  571. if test -n "${__MY_DTACH}"
  572. then
  573. # if already in dtach session print current session
  574. soc_name="`basename "$__MY_DTACH"`"
  575. echo "Current session: ${soc_name}"
  576. fi
  577. if test -z "$1"
  578. then
  579. # if no arg given show list of sessions
  580. echo "Sessions:"
  581. ls "${__dtach_dir}"
  582. return 0
  583. elif test "$1" = "-h"
  584. then
  585. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  586. return 1
  587. fi
  588. # set socket name
  589. soc_name="${__dtach_dir}/$1"
  590. shift
  591. if test -n "$__MY_DTACH"
  592. then
  593. echo "dtach session cannot be nested." 1>&2
  594. return 1
  595. elif test -S "$soc_name"
  596. then
  597. dtach -a "$soc_name" -e ^^
  598. elif test -e "$soc_name"
  599. then
  600. echo "dt: File named $soc_name already exists."
  601. return 1
  602. elif test -z "$1"
  603. then
  604. # if no command given invoke current shell
  605. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  606. # echo "dt: Socket named $soc_name not exists and no command specified."
  607. # return 1
  608. else
  609. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  610. fi
  611. }
  612. scr(){
  613. test -n "$1" && pf="${1}-"
  614. ___tformat="%Y%m%d-%H%M%S%z"
  615. ___file="${HOME}/${pf}`date +${___tformat}`.script"
  616. __MY_SCRIPT=${___file} script ${___file} "$@"
  617. }
  618. dtscr(){
  619. # dtscr <command ...>
  620. if test -z "$1"
  621. then
  622. echo "dtscr: usage: dtscr <command ...>"
  623. return 1
  624. fi
  625. ___cmdstr="`echo $@ | tr ' ' +`"
  626. ___tformat="%Y%m%d-%H%M%S%z"
  627. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  628. ___scr_file="${HOME}/${___name}.script"
  629. ___dt_dir="${TMP}/dtscr"
  630. mkdir -p "$___dt_dir"
  631. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  632. # echo $_name
  633. # echo $_file
  634. }
  635. mcrypt_stream(){
  636. test $# -eq 2 || return 1
  637. case $1 in
  638. en)
  639. mcrypt --key $2 | base64 ;;
  640. de)
  641. base64 -d | mcrypt -d --key $2 ;;
  642. esac
  643. }
  644. gpg_stream(){
  645. test $# -eq 2 || return 1
  646. case $1 in
  647. en)
  648. gpg --passphrase $2 -c --batch |base64 ;;
  649. de)
  650. base64 -d|gpg --passphrase $2 -d --batch ;;
  651. esac
  652. }
  653. dgpg(){
  654. if test "$1" = help || test -z "$2"
  655. then
  656. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  657. return
  658. fi
  659. ___srcs="$2"
  660. ___dsts="$3"
  661. test -z "$___dsts" && ___dsts="${___srcs}.out"
  662. ___pw=
  663. echo -n "dgpg pw: "
  664. read -s ___pw
  665. echo ""
  666. test -z "$___pw" && return 1
  667. for f in *${___srcs}
  668. do
  669. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  670. echo -n "Processing $f to $___d..."
  671. if test -d "$f"
  672. then
  673. echo "`printf 'failed (%s is directory)' $f`"
  674. elif test -f "$___d"
  675. then
  676. echo "`printf 'failed (%s is already exists)' $___d`"
  677. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  678. then
  679. echo "done"
  680. else
  681. echo "failed"
  682. test -f "$___d" && rm "$___d"
  683. fi
  684. done
  685. }
  686. alias enst="gpg_stream en"
  687. alias dest="gpg_stream de"
  688. showinfo(){
  689. echo "Japanese letters are 表示可能"
  690. __safe_run diskinfo
  691. ! $isdarwin && test -n "${DISPLAY}" && {
  692. __safe_run xrandr | \grep --color=never ^Screen
  693. }
  694. $iswindows || __safe_run finger $USER
  695. LANG=C __safe_runc id
  696. __safe_run xset q
  697. }
  698. x(){
  699. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  700. #mkdir -p ~/.var/log
  701. # nohup startx >~/.var/log/xorg.log 2>&1 &
  702. # exit
  703. exec startx
  704. else
  705. echo "X cant be started! Another X is already running?" 1>&2
  706. fi
  707. }
  708. bak(){
  709. for file in "$@"
  710. do
  711. cp -v ${file} ${file}.bak
  712. done
  713. }
  714. di(){
  715. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  716. then
  717. ___diffcmd=colordiff
  718. else
  719. ___diffcmd=diff
  720. fi
  721. ${___diffcmd} -u "$@" | ${PAGER}
  722. }
  723. tb(){
  724. __datenum=`date +%Y%m%d-%H%M%S`
  725. __tb="$HOME/.var/tb/$__datenum"
  726. mkdir -p "$__tb"
  727. mv "$@" "$__tb"
  728. }
  729. mkdd(){
  730. _d=`date +%Y%m%d-%H%M%S` && \
  731. mkdir -p "$_d"
  732. }
  733. mkcd(){
  734. if test -z "$1"
  735. then
  736. echo "mkcd: usage: mkcd <dir>"
  737. return 1
  738. elif test -d "$1"
  739. then
  740. echo "Dir \"$1\" already exists."
  741. else
  742. mkdir -p "$1"
  743. echo "Dir \"$1\" created."
  744. fi
  745. cd "$1"
  746. }
  747. mkcdd(){
  748. # make and change date directory
  749. _d=`date +%Y%m%d-%H%M%S` && \
  750. mkcd "$_d"
  751. }
  752. if test -n "$TMUX" && null type reattach-to-user-namespace
  753. then
  754. alias pbpaste="reattach-to-user-namespace pbpaste"
  755. alias pbcopy="reattach-to-user-namespace pbcopy"
  756. fi
  757. catclip(){
  758. if $iswindows
  759. then
  760. cat /dev/clipboard | tr -d \\r
  761. elif $isdarwin
  762. then
  763. pbpaste
  764. else
  765. xclip -o -selection "clipboard"
  766. fi
  767. }
  768. setclip(){
  769. if test $# -eq 0
  770. then
  771. exec 3<&0
  772. else
  773. exec 3<<__EOF__
  774. `cat "$@"`
  775. __EOF__
  776. fi
  777. if $iswindows
  778. then
  779. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  780. elif $isdarwin
  781. then
  782. pbcopy 0<&3
  783. else
  784. 0<&3 xclip -i -f -selection "primary" | \
  785. xclip -i -f -selection "clipboard"
  786. fi
  787. exec 3<&-
  788. }
  789. open_file(){
  790. if $iscygwin
  791. then
  792. cygstart "$@"
  793. elif $ismsys
  794. then
  795. cmd.exe //c start "" "$@"
  796. elif $isdarwin
  797. then
  798. touch "$@"
  799. open "$@"
  800. elif $islinux
  801. then
  802. touch "$@"
  803. if null type pcmanfm; then
  804. LC_MESSAGES= pcmanfm "$@"
  805. else
  806. LC_MESSAGES= xdg-open "$@" &
  807. fi
  808. else
  809. cat "$@"
  810. fi
  811. }
  812. o(){
  813. if test $# -eq 0
  814. then
  815. open_file .
  816. else
  817. for f in "$@"
  818. do
  819. open_file "$(realpath "$f")"
  820. done
  821. fi
  822. }
  823. convmv_sjis2utf8_test(){
  824. convmv -r -f sjis -t utf8 *
  825. }
  826. convmv_sjis2utf8_notest(){
  827. convmv -r -f sjis -t utf8 * --notest
  828. }
  829. #################################################
  830. ## pastebin services
  831. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  832. sprunge(){
  833. # http://sprunge.us
  834. if test -z "$1"
  835. then
  836. curl -F 'sprunge=<-' http://sprunge.us
  837. else
  838. curl http://sprunge.us/$1
  839. fi
  840. }
  841. dpaste(){
  842. # http://dpaste.de
  843. if test -z "$1"
  844. then
  845. curl -F 'content=<-' https://dpaste.de/api/
  846. echo
  847. else
  848. curl https://dpaste.de/$1/raw/
  849. fi
  850. }
  851. ######################################
  852. ## Prompt Settings
  853. __my_moc_state(){
  854. type mocp >/dev/null 2>&1 || return
  855. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  856. printf "$1" "`mocp -Q %title 2>/dev/null`"
  857. }
  858. __my_parse_svn_branch() {
  859. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  860. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  861. sed -ne 's#^Repository Root: ##p')
  862. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  863. awk '{print $1}'
  864. }
  865. __my_svn_ps1(){
  866. if svn status >/dev/null 2>&1
  867. then
  868. ___svn_branch=$(__my_parse_svn_branch)
  869. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  870. fi
  871. }
  872. __my_battery_status(){
  873. ___dir=/sys/class/power_supply/BAT0
  874. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  875. test -r $___dir/charge_now
  876. then
  877. ___st=$(cat $___dir/status)
  878. ___full=$(cat $___dir/charge_full)
  879. ___now=$(cat $___dir/charge_now)
  880. ___rate=$(expr "$___now" \* 100 / "$___full")
  881. printf "$1" "${___st}:${___rate}%"
  882. fi
  883. }
  884. alias bat='__my_battery_status %s\\n'
  885. __my_ps1_scale(){
  886. if null type stty && ! $ismsys
  887. then
  888. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  889. fi
  890. }
  891. __my_ps1_tmux(){
  892. null type tmux || return $last
  893. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  894. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  895. }
  896. __my_ps1_moc(){
  897. __my_moc_state "[MOC:%s]"
  898. }
  899. for f in /usr/share/git/git-prompt.sh \
  900. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  901. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  902. /usr/share/git-core/contrib/completion/git-prompt.sh \
  903. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  904. /etc/bash_completion.d/git-prompt \
  905. /opt/local/share/git-core/git-prompt.sh \
  906. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  907. do
  908. test -r "$f" && ($inbash || $inzsh) && . "$f" && break
  909. done
  910. export GIT_PS1_SHOWDIRTYSTATE=t
  911. export GIT_PS1_SHOWUPSTREAM=t
  912. __my_ps1_git(){
  913. null type __git_ps1 || return $last
  914. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  915. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  916. }
  917. __printf_ipaddr(){
  918. # ipaddress <fmt>
  919. type ip >/dev/null 2>&1 || return 1
  920. ___ip=$(LANG=C ip addr show scope global | \
  921. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  922. test -n "$___ip" && printf "$1" $___ip
  923. }
  924. alias addr="__printf_ipaddr '%s'"
  925. __my_ps1_ipaddr(){
  926. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  927. }
  928. __my_ps1_bttry(){
  929. ___bst="$__homerun/batterystatus"
  930. if test -z "$DISPLAY" && ! $iswindows
  931. then
  932. test -f $___bst && ___bstr="$(cat $___bst)"
  933. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  934. echo "[Battery:${___bstr}]"
  935. __my_battery_status %s >$___bst &
  936. fi
  937. }
  938. __my_ps1_memo(){
  939. test -f memo.txt && echo "m:`du -b memo.txt|cut -f 1`"
  940. }
  941. __my_ps1_dirs(){
  942. dirs | wc -l
  943. }
  944. __my_ps1_jobs(){
  945. # __my_ps1_jobs [<num>]
  946. if test -n "$1"
  947. then
  948. jobs="$1"
  949. else
  950. jobs="`jobs | wc -l`"
  951. fi
  952. if test "$jobs" -gt 0
  953. then
  954. echo "JOBS:$jobs"
  955. fi
  956. }
  957. __my_ps1_dollar(){
  958. if test -z "$SHLVL"
  959. then
  960. printf "$1"
  961. else
  962. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  963. fi
  964. }
  965. __my_alert_fail(){
  966. test $laststatus -eq 0 || \
  967. echo "STATUS:${laststatus}"
  968. }
  969. # About ansi escape sequences
  970. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  971. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  972. if $inbash || $inzsh
  973. then
  974. if $inzsh
  975. then
  976. __attr_beg=$'%{\033['
  977. __attr_end='m%}'
  978. else
  979. __attr_beg='\[\033['
  980. __attr_end='m\]'
  981. fi
  982. __color_default="${__attr_beg}0${__attr_end}"
  983. __color_black="${__attr_beg}0;30${__attr_end}"
  984. __color_red="${__attr_beg}0;31${__attr_end}"
  985. __color_green="${__attr_beg}0;32${__attr_end}"
  986. __color_yellow="${__attr_beg}0;33${__attr_end}"
  987. __color_blue="${__attr_beg}0;34${__attr_end}"
  988. __color_magenta="${__attr_beg}0;35${__attr_end}"
  989. __color_cyan="${__attr_beg}0;36${__attr_end}"
  990. __color_white="${__attr_beg}0;37${__attr_end}"
  991. __color_light_black="${__attr_beg}1;30${__attr_end}"
  992. __color_light_red="${__attr_beg}1;31${__attr_end}"
  993. __color_light_green="${__attr_beg}1;32${__attr_end}"
  994. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  995. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  996. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  997. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  998. __color_light_white="${__attr_beg}1;37${__attr_end}"
  999. __color_bg_black="${__attr_beg}40${__attr_end}"
  1000. __color_bg_red="${__attr_beg}41${__attr_end}"
  1001. __color_bg_green="${__attr_beg}42${__attr_end}"
  1002. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1003. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1004. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1005. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1006. __color_bg_white="${__attr_beg}47${__attr_end}"
  1007. __attr_underline="${__attr_beg}4${__attr_end}"
  1008. __attr_reverse="${__attr_beg}7${__attr_end}"
  1009. __attr_bold="${__attr_beg}1${__attr_end}"
  1010. fi
  1011. # NOTE: tput is another easy way to set colors and background
  1012. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1013. # color blue.
  1014. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1015. if test "$TERM" != dumb
  1016. then
  1017. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1018. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1019. # color for ::
  1020. if test -z "$_HOSTCOLOR_1"
  1021. then
  1022. # default color used by tmux status line
  1023. _HOSTCOLOR_1=green
  1024. fi
  1025. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1026. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1027. __my_cdef="$__color_default"
  1028. fi
  1029. if $inbash
  1030. then
  1031. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1032. elif $inzsh
  1033. then
  1034. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1035. fi
  1036. __my_ps1_info1(){
  1037. # first line of PS1
  1038. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1039. }
  1040. test -n "$__MY_SCRIPT" && \
  1041. __my_ps1_str_scr="SCR"
  1042. test -n "$SSH_CONNECTION" && \
  1043. __my_ps1_str_ssh="SSH"
  1044. test -n "$__MY_DTACH" && \
  1045. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1046. __my_ps1_info2(){
  1047. # second line of PS1
  1048. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1049. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1050. | sed -e 's/ /|/g'
  1051. }
  1052. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1053. __my_ps1_save_pos="\[\033[s\]"
  1054. __my_ps1_restore_pos="\[\033[u\]"
  1055. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1056. __my_ps1_move_15left="\[\033[15D\]"
  1057. # collapse when command line is too long and try to write over this string
  1058. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1059. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1060. if $inzsh
  1061. then
  1062. PROMPT="\
  1063. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1064. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1065. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1066. elif $inbash
  1067. then
  1068. PS1="\
  1069. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1070. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1071. else
  1072. true
  1073. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1074. fi
  1075. ###################################
  1076. # set header and titles
  1077. __my_set_header_line(){
  1078. # save current position
  1079. printf "\033[s"
  1080. # move to 0,0
  1081. printf "\033[0;0H"
  1082. # clear curent to eol
  1083. printf "\033[K"
  1084. # inverse color
  1085. printf "\033[7m"
  1086. printf "$1"
  1087. # restore color
  1088. printf "\033[0m"
  1089. # restore saved position
  1090. printf "\033[u"
  1091. }
  1092. __my_set_screen_name(){
  1093. # set window name
  1094. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1095. then
  1096. echo -ne "\033k$1\033\\"
  1097. fi
  1098. }
  1099. __my_set_title(){
  1100. case $TERM in
  1101. (rxvt*|xterm*|aterm|screen*)
  1102. test -t 1 &&
  1103. test -z "$EMACS" &&
  1104. echo -n -e "\033]0;$1\007"
  1105. ;;
  1106. esac
  1107. }
  1108. if test -n "$TMUX"
  1109. then
  1110. # running tmux locally
  1111. __terminal_title="\$(basename \${PWD})"
  1112. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1113. then
  1114. # ssh connect from tmux terminal
  1115. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1116. else
  1117. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1118. fi
  1119. if $inzsh
  1120. then
  1121. precmd(){
  1122. laststatus=$?
  1123. eval __my_set_title ${__terminal_title}
  1124. }
  1125. else
  1126. if test -n "$PROMPT_COMMAND"
  1127. then
  1128. PROMPT_COMMAND="laststatus=\$?;$PROMPT_COMMAND;__my_set_title \"${__terminal_title}\""
  1129. else
  1130. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\""
  1131. fi
  1132. fi
  1133. laststatus=0